/* CertButton.c generated by valac 0.56.14, the Vala compiler
 * generated from CertButton.vala, do not modify */

/*
* Copyright (c) 2016-2017 elementary LLC (http://launchpad.net/capnet-assist)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include <handy.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gcr/gcr-base.h>
#include <ui/gcr-ui.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CERT_BUTTON (cert_button_get_type ())
#define CERT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CERT_BUTTON, CertButton))
#define CERT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CERT_BUTTON, CertButtonClass))
#define IS_CERT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CERT_BUTTON))
#define IS_CERT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CERT_BUTTON))
#define CERT_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CERT_BUTTON, CertButtonClass))

typedef struct _CertButton CertButton;
typedef struct _CertButtonClass CertButtonClass;
typedef struct _CertButtonPrivate CertButtonPrivate;
typedef enum  {
	CERT_BUTTON_SECURITY_NONE,
	CERT_BUTTON_SECURITY_SECURE,
	CERT_BUTTON_SECURITY_LOADING,
	CERT_BUTTON_SECURITY_MIXED_CONTENT
} CertButtonSecurity;

#define CERT_BUTTON_TYPE_SECURITY (cert_button_security_get_type ())

#define TYPE_CAPTIVE_LOGIN (captive_login_get_type ())
#define CAPTIVE_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CAPTIVE_LOGIN, CaptiveLogin))
#define CAPTIVE_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CAPTIVE_LOGIN, CaptiveLoginClass))
#define IS_CAPTIVE_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CAPTIVE_LOGIN))
#define IS_CAPTIVE_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CAPTIVE_LOGIN))
#define CAPTIVE_LOGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CAPTIVE_LOGIN, CaptiveLoginClass))

typedef struct _CaptiveLogin CaptiveLogin;
typedef struct _CaptiveLoginClass CaptiveLoginClass;
enum  {
	CERT_BUTTON_0_PROPERTY,
	CERT_BUTTON_SECURITY_PROPERTY,
	CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY,
	CERT_BUTTON_NUM_PROPERTIES
};
static GParamSpec* cert_button_properties[CERT_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))

struct _CertButton {
	GtkToggleButton parent_instance;
	CertButtonPrivate * priv;
};

struct _CertButtonClass {
	GtkToggleButtonClass parent_class;
};

struct _CertButtonPrivate {
	CertButtonSecurity _security;
	CaptiveLogin* _captive_login_window;
};

struct _Block3Data {
	int _ref_count_;
	CertButton* self;
	GtkPopover* popover;
};

static gint CertButton_private_offset;
static gpointer cert_button_parent_class = NULL;

VALA_EXTERN GType cert_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CertButton, g_object_unref)
VALA_EXTERN GType cert_button_security_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType captive_login_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CaptiveLogin, g_object_unref)
VALA_EXTERN CertButton* cert_button_new (CaptiveLogin* captive_login_window);
VALA_EXTERN CertButton* cert_button_construct (GType object_type,
                                   CaptiveLogin* captive_login_window);
static void cert_button_on_tls_button_click (CertButton* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN CaptiveLogin* cert_button_get_captive_login_window (CertButton* self);
VALA_EXTERN gboolean captive_login_get_tls_info (CaptiveLogin* self,
                                     GTlsCertificate** certificate,
                                     GTlsCertificateFlags* errors);
VALA_EXTERN gchar* captive_login_get_uri (CaptiveLogin* self);
VALA_EXTERN CertButtonSecurity cert_button_get_security (CertButton* self);
static gboolean __lambda7_ (CertButton* self,
                     GdkEventButton* event);
static gboolean ___lambda7__gtk_widget_button_press_event (GtkWidget* _sender,
                                                    GdkEventButton* event,
                                                    gpointer self);
static gboolean __lambda8_ (Block3Data* _data3_,
                     GdkEventButton* event);
static gboolean ___lambda8__gtk_widget_button_release_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
VALA_EXTERN void cert_button_set_security (CertButton* self,
                               CertButtonSecurity value);
VALA_EXTERN void cert_button_set_captive_login_window (CertButton* self,
                                           CaptiveLogin* value);
static GObject * cert_button_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _cert_button_on_tls_button_click_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                 gpointer self);
static void cert_button_finalize (GObject * obj);
static GType cert_button_get_type_once (void);
static void _vala_cert_button_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_cert_button_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
cert_button_get_instance_private (CertButton* self)
{
	return G_STRUCT_MEMBER_P (self, CertButton_private_offset);
}

static GType
cert_button_security_get_type_once (void)
{
	static const GEnumValue values[] = {{CERT_BUTTON_SECURITY_NONE, "CERT_BUTTON_SECURITY_NONE", "none"}, {CERT_BUTTON_SECURITY_SECURE, "CERT_BUTTON_SECURITY_SECURE", "secure"}, {CERT_BUTTON_SECURITY_LOADING, "CERT_BUTTON_SECURITY_LOADING", "loading"}, {CERT_BUTTON_SECURITY_MIXED_CONTENT, "CERT_BUTTON_SECURITY_MIXED_CONTENT", "mixed-content"}, {0, NULL, NULL}};
	GType cert_button_security_type_id;
	cert_button_security_type_id = g_enum_register_static ("CertButtonSecurity", values);
	return cert_button_security_type_id;
}

GType
cert_button_security_get_type (void)
{
	static volatile gsize cert_button_security_type_id__once = 0;
	if (g_once_init_enter (&cert_button_security_type_id__once)) {
		GType cert_button_security_type_id;
		cert_button_security_type_id = cert_button_security_get_type_once ();
		g_once_init_leave (&cert_button_security_type_id__once, cert_button_security_type_id);
	}
	return cert_button_security_type_id__once;
}

CertButton*
cert_button_construct (GType object_type,
                       CaptiveLogin* captive_login_window)
{
	CertButton * self = NULL;
#line 75 "../src/CertButton.vala"
	g_return_val_if_fail (captive_login_window != NULL, NULL);
#line 76 "../src/CertButton.vala"
	self = (CertButton*) g_object_new (object_type, "security", CERT_BUTTON_SECURITY_LOADING, "captive-login-window", captive_login_window, NULL);
#line 75 "../src/CertButton.vala"
	return self;
#line 205 "CertButton.c"
}

CertButton*
cert_button_new (CaptiveLogin* captive_login_window)
{
#line 75 "../src/CertButton.vala"
	return cert_button_construct (TYPE_CERT_BUTTON, captive_login_window);
#line 213 "CertButton.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 87 "../src/CertButton.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 87 "../src/CertButton.vala"
	return _data3_;
#line 223 "CertButton.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 87 "../src/CertButton.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 233 "CertButton.c"
		CertButton* self;
#line 87 "../src/CertButton.vala"
		self = _data3_->self;
#line 87 "../src/CertButton.vala"
		_g_object_unref0 (_data3_->popover);
#line 87 "../src/CertButton.vala"
		_g_object_unref0 (self);
#line 87 "../src/CertButton.vala"
		g_slice_free (Block3Data, _data3_);
#line 243 "CertButton.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 110 "../src/CertButton.vala"
	return self ? g_object_ref (self) : NULL;
#line 252 "CertButton.c"
}

static gboolean
__lambda7_ (CertButton* self,
            GdkEventButton* event)
{
	gboolean result;
#line 153 "../src/CertButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 154 "../src/CertButton.vala"
	result = TRUE;
#line 154 "../src/CertButton.vala"
	return result;
#line 266 "CertButton.c"
}

static gboolean
___lambda7__gtk_widget_button_press_event (GtkWidget* _sender,
                                           GdkEventButton* event,
                                           gpointer self)
{
	gboolean result;
	result = __lambda7_ ((CertButton*) self, event);
#line 153 "../src/CertButton.vala"
	return result;
#line 278 "CertButton.c"
}

static gboolean
__lambda8_ (Block3Data* _data3_,
            GdkEventButton* event)
{
	CertButton* self;
	GtkWidget* child = NULL;
	GtkPopover* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* event_widget = NULL;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GtkWidget* _tmp6_;
	gboolean result;
#line 157 "../src/CertButton.vala"
	self = _data3_->self;
#line 157 "../src/CertButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 158 "../src/CertButton.vala"
	_tmp0_ = _data3_->popover;
#line 158 "../src/CertButton.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
#line 158 "../src/CertButton.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 158 "../src/CertButton.vala"
	child = _tmp2_;
#line 159 "../src/CertButton.vala"
	_tmp3_ = gtk_get_event_widget ((GdkEvent*) event);
#line 159 "../src/CertButton.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 159 "../src/CertButton.vala"
	event_widget = _tmp4_;
#line 161 "../src/CertButton.vala"
	_tmp6_ = child;
#line 161 "../src/CertButton.vala"
	if (_tmp6_ != NULL) {
#line 318 "CertButton.c"
		GdkWindow* _tmp7_;
		GtkPopover* _tmp8_;
		GdkWindow* _tmp9_;
#line 161 "../src/CertButton.vala"
		_tmp7_ = event->window;
#line 161 "../src/CertButton.vala"
		_tmp8_ = _data3_->popover;
#line 161 "../src/CertButton.vala"
		_tmp9_ = gtk_widget_get_window ((GtkWidget*) _tmp8_);
#line 161 "../src/CertButton.vala"
		_tmp5_ = _tmp7_ == _tmp9_;
#line 330 "CertButton.c"
	} else {
#line 161 "../src/CertButton.vala"
		_tmp5_ = FALSE;
#line 334 "CertButton.c"
	}
#line 161 "../src/CertButton.vala"
	if (_tmp5_) {
#line 338 "CertButton.c"
		GtkAllocation child_alloc = {0};
		GtkPopover* _tmp10_;
		GtkAllocation _tmp11_ = {0};
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		GtkAllocation _tmp15_;
#line 163 "../src/CertButton.vala"
		_tmp10_ = _data3_->popover;
#line 163 "../src/CertButton.vala"
		gtk_widget_get_allocation ((GtkWidget*) _tmp10_, &_tmp11_);
#line 163 "../src/CertButton.vala"
		child_alloc = _tmp11_;
#line 165 "../src/CertButton.vala"
		_tmp15_ = child_alloc;
#line 165 "../src/CertButton.vala"
		if (event->x < ((gdouble) _tmp15_.x)) {
#line 165 "../src/CertButton.vala"
			_tmp14_ = TRUE;
#line 358 "CertButton.c"
		} else {
			GtkAllocation _tmp16_;
			GtkAllocation _tmp17_;
#line 166 "../src/CertButton.vala"
			_tmp16_ = child_alloc;
#line 166 "../src/CertButton.vala"
			_tmp17_ = child_alloc;
#line 166 "../src/CertButton.vala"
			_tmp14_ = event->x > ((gdouble) (_tmp16_.x + _tmp17_.width));
#line 368 "CertButton.c"
		}
#line 165 "../src/CertButton.vala"
		if (_tmp14_) {
#line 165 "../src/CertButton.vala"
			_tmp13_ = TRUE;
#line 374 "CertButton.c"
		} else {
			GtkAllocation _tmp18_;
#line 167 "../src/CertButton.vala"
			_tmp18_ = child_alloc;
#line 167 "../src/CertButton.vala"
			_tmp13_ = event->y < ((gdouble) _tmp18_.y);
#line 381 "CertButton.c"
		}
#line 165 "../src/CertButton.vala"
		if (_tmp13_) {
#line 165 "../src/CertButton.vala"
			_tmp12_ = TRUE;
#line 387 "CertButton.c"
		} else {
			GtkAllocation _tmp19_;
			GtkAllocation _tmp20_;
#line 168 "../src/CertButton.vala"
			_tmp19_ = child_alloc;
#line 168 "../src/CertButton.vala"
			_tmp20_ = child_alloc;
#line 168 "../src/CertButton.vala"
			_tmp12_ = event->y > ((gdouble) (_tmp19_.y + _tmp20_.height));
#line 397 "CertButton.c"
		}
#line 165 "../src/CertButton.vala"
		if (_tmp12_) {
#line 401 "CertButton.c"
			GtkPopover* _tmp21_;
#line 169 "../src/CertButton.vala"
			_tmp21_ = _data3_->popover;
#line 169 "../src/CertButton.vala"
			gtk_widget_hide ((GtkWidget*) _tmp21_);
#line 170 "../src/CertButton.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
#line 409 "CertButton.c"
		}
	} else {
		gboolean _tmp22_ = FALSE;
		GtkWidget* _tmp23_;
#line 172 "../src/CertButton.vala"
		_tmp23_ = event_widget;
#line 172 "../src/CertButton.vala"
		if (_tmp23_ != NULL) {
#line 418 "CertButton.c"
			GtkWidget* _tmp24_;
			GtkPopover* _tmp25_;
#line 172 "../src/CertButton.vala"
			_tmp24_ = event_widget;
#line 172 "../src/CertButton.vala"
			_tmp25_ = _data3_->popover;
#line 172 "../src/CertButton.vala"
			_tmp22_ = !gtk_widget_is_ancestor (_tmp24_, (GtkWidget*) _tmp25_);
#line 427 "CertButton.c"
		} else {
#line 172 "../src/CertButton.vala"
			_tmp22_ = FALSE;
#line 431 "CertButton.c"
		}
#line 172 "../src/CertButton.vala"
		if (_tmp22_) {
#line 435 "CertButton.c"
			GtkPopover* _tmp26_;
#line 173 "../src/CertButton.vala"
			_tmp26_ = _data3_->popover;
#line 173 "../src/CertButton.vala"
			gtk_widget_hide ((GtkWidget*) _tmp26_);
#line 174 "../src/CertButton.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
#line 443 "CertButton.c"
		}
	}
#line 177 "../src/CertButton.vala"
	result = TRUE;
#line 177 "../src/CertButton.vala"
	_g_object_unref0 (event_widget);
#line 177 "../src/CertButton.vala"
	_g_object_unref0 (child);
#line 177 "../src/CertButton.vala"
	return result;
#line 454 "CertButton.c"
}

static gboolean
___lambda8__gtk_widget_button_release_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = __lambda8_ (self, event);
#line 157 "../src/CertButton.vala"
	return result;
#line 466 "CertButton.c"
}

static void
cert_button_on_tls_button_click (CertButton* self)
{
	Block3Data* _data3_;
	GTlsCertificate* cert = NULL;
	GTlsCertificateFlags cert_flags = 0U;
	CaptiveLogin* _tmp0_;
	GTlsCertificate* _tmp1_ = NULL;
	GTlsCertificateFlags _tmp2_ = 0U;
	gboolean _tmp3_;
	GtkPopover* _tmp4_;
	GtkPopover* _tmp5_;
	GIcon* button_icon = NULL;
	GtkWidget* _tmp6_;
	GIcon* _tmp7_ = NULL;
	GIcon* _tmp8_;
	GtkImage* icon = NULL;
	GIcon* _tmp9_;
	GtkImage* _tmp10_;
	GtkImage* _tmp11_;
	GtkLabel* primary_text = NULL;
	CaptiveLogin* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkLabel* _tmp23_;
	GtkLabel* secondary_text = NULL;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	CertButtonSecurity _tmp30_;
	CertButtonSecurity _tmp31_;
	GcrSimpleCertificate* gcr_cert = NULL;
	GTlsCertificate* _tmp40_;
	GByteArray* _tmp41_;
	GByteArray* _tmp42_;
	GByteArray* _tmp43_;
	guint8* _tmp44_;
	gint _tmp44__length1;
	GcrSimpleCertificate* _tmp45_;
	GcrSimpleCertificate* _tmp46_;
	GcrCertificateWidget* cert_details = NULL;
	GcrSimpleCertificate* _tmp47_;
	GcrCertificateWidget* _tmp48_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp49_;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkImage* _tmp52_;
	GtkGrid* _tmp53_;
	GtkLabel* _tmp54_;
	GtkGrid* _tmp55_;
	GtkLabel* _tmp56_;
	GtkGrid* _tmp57_;
	GcrCertificateWidget* _tmp58_;
	GtkPopover* _tmp59_;
	GtkGrid* _tmp60_;
	GtkPopover* _tmp61_;
	GtkPopover* _tmp62_;
	GtkPopover* _tmp63_;
#line 87 "../src/CertButton.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/CertButton.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 87 "../src/CertButton.vala"
	_data3_->_ref_count_ = 1;
#line 87 "../src/CertButton.vala"
	_data3_->self = g_object_ref (self);
#line 91 "../src/CertButton.vala"
	if (!gtk_toggle_button_get_active ((GtkToggleButton*) self)) {
#line 92 "../src/CertButton.vala"
		_g_object_unref0 (cert);
#line 92 "../src/CertButton.vala"
		block3_data_unref (_data3_);
#line 92 "../src/CertButton.vala"
		_data3_ = NULL;
#line 92 "../src/CertButton.vala"
		return;
#line 557 "CertButton.c"
	}
#line 95 "../src/CertButton.vala"
	_tmp0_ = self->priv->_captive_login_window;
#line 95 "../src/CertButton.vala"
	_tmp3_ = captive_login_get_tls_info (_tmp0_, &_tmp1_, &_tmp2_);
#line 95 "../src/CertButton.vala"
	_g_object_unref0 (cert);
#line 95 "../src/CertButton.vala"
	cert = _tmp1_;
#line 95 "../src/CertButton.vala"
	cert_flags = _tmp2_;
#line 95 "../src/CertButton.vala"
	if (!_tmp3_) {
#line 96 "../src/CertButton.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
#line 97 "../src/CertButton.vala"
		_g_object_unref0 (cert);
#line 97 "../src/CertButton.vala"
		block3_data_unref (_data3_);
#line 97 "../src/CertButton.vala"
		_data3_ = NULL;
#line 97 "../src/CertButton.vala"
		return;
#line 581 "CertButton.c"
	}
#line 100 "../src/CertButton.vala"
	_tmp4_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
#line 100 "../src/CertButton.vala"
	g_object_ref_sink (_tmp4_);
#line 100 "../src/CertButton.vala"
	_data3_->popover = _tmp4_;
#line 101 "../src/CertButton.vala"
	_tmp5_ = _data3_->popover;
#line 101 "../src/CertButton.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp5_, (guint) 12);
#line 110 "../src/CertButton.vala"
	_tmp6_ = gtk_button_get_image ((GtkButton*) self);
#line 110 "../src/CertButton.vala"
	gtk_image_get_gicon (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_image_get_type (), GtkImage), &_tmp7_, (GtkIconSize*) NULL);
#line 110 "../src/CertButton.vala"
	_g_object_unref0 (button_icon);
#line 110 "../src/CertButton.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 110 "../src/CertButton.vala"
	button_icon = _tmp8_;
#line 115 "../src/CertButton.vala"
	_tmp9_ = button_icon;
#line 115 "../src/CertButton.vala"
	_tmp10_ = (GtkImage*) gtk_image_new_from_gicon (_tmp9_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 115 "../src/CertButton.vala"
	g_object_ref_sink (_tmp10_);
#line 115 "../src/CertButton.vala"
	icon = _tmp10_;
#line 116 "../src/CertButton.vala"
	_tmp11_ = icon;
#line 116 "../src/CertButton.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp11_, GTK_ALIGN_START);
#line 118 "../src/CertButton.vala"
	_tmp12_ = self->priv->_captive_login_window;
#line 118 "../src/CertButton.vala"
	_tmp13_ = captive_login_get_uri (_tmp12_);
#line 118 "../src/CertButton.vala"
	_tmp14_ = _tmp13_;
#line 118 "../src/CertButton.vala"
	_tmp15_ = (GtkLabel*) gtk_label_new (_tmp14_);
#line 118 "../src/CertButton.vala"
	g_object_ref_sink (_tmp15_);
#line 118 "../src/CertButton.vala"
	_tmp16_ = _tmp15_;
#line 118 "../src/CertButton.vala"
	_g_free0 (_tmp14_);
#line 118 "../src/CertButton.vala"
	primary_text = _tmp16_;
#line 119 "../src/CertButton.vala"
	_tmp17_ = primary_text;
#line 119 "../src/CertButton.vala"
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
#line 119 "../src/CertButton.vala"
	gtk_style_context_add_class (_tmp18_, "h3");
#line 120 "../src/CertButton.vala"
	_tmp19_ = primary_text;
#line 120 "../src/CertButton.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp19_, GTK_ALIGN_START);
#line 121 "../src/CertButton.vala"
	_tmp20_ = primary_text;
#line 121 "../src/CertButton.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp20_, 9);
#line 122 "../src/CertButton.vala"
	_tmp21_ = primary_text;
#line 122 "../src/CertButton.vala"
	gtk_label_set_max_width_chars (_tmp21_, 70);
#line 123 "../src/CertButton.vala"
	_tmp22_ = primary_text;
#line 123 "../src/CertButton.vala"
	g_object_set (_tmp22_, "wrap", TRUE, NULL);
#line 124 "../src/CertButton.vala"
	_tmp23_ = primary_text;
#line 124 "../src/CertButton.vala"
	g_object_set (_tmp23_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
#line 126 "../src/CertButton.vala"
	_tmp24_ = gtk_widget_get_tooltip_text ((GtkWidget*) self);
#line 126 "../src/CertButton.vala"
	_tmp25_ = _tmp24_;
#line 126 "../src/CertButton.vala"
	_tmp26_ = (GtkLabel*) gtk_label_new (_tmp25_);
#line 126 "../src/CertButton.vala"
	g_object_ref_sink (_tmp26_);
#line 126 "../src/CertButton.vala"
	_tmp27_ = _tmp26_;
#line 126 "../src/CertButton.vala"
	_g_free0 (_tmp25_);
#line 126 "../src/CertButton.vala"
	secondary_text = _tmp27_;
#line 127 "../src/CertButton.vala"
	_tmp28_ = secondary_text;
#line 127 "../src/CertButton.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp28_, GTK_ALIGN_START);
#line 128 "../src/CertButton.vala"
	_tmp29_ = secondary_text;
#line 128 "../src/CertButton.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp29_, 9);
#line 130 "../src/CertButton.vala"
	_tmp30_ = cert_button_get_security (self);
#line 130 "../src/CertButton.vala"
	_tmp31_ = _tmp30_;
#line 130 "../src/CertButton.vala"
	if (_tmp31_ == CERT_BUTTON_SECURITY_SECURE) {
#line 685 "CertButton.c"
		GtkImage* _tmp32_;
		GtkStyleContext* _tmp33_;
		GtkLabel* _tmp34_;
		GtkStyleContext* _tmp35_;
#line 131 "../src/CertButton.vala"
		_tmp32_ = icon;
#line 131 "../src/CertButton.vala"
		_tmp33_ = gtk_widget_get_style_context ((GtkWidget*) _tmp32_);
#line 131 "../src/CertButton.vala"
		gtk_style_context_add_class (_tmp33_, "success");
#line 132 "../src/CertButton.vala"
		_tmp34_ = secondary_text;
#line 132 "../src/CertButton.vala"
		_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
#line 132 "../src/CertButton.vala"
		gtk_style_context_add_class (_tmp35_, "success");
#line 702 "CertButton.c"
	} else {
		GtkImage* _tmp36_;
		GtkStyleContext* _tmp37_;
		GtkLabel* _tmp38_;
		GtkStyleContext* _tmp39_;
#line 134 "../src/CertButton.vala"
		_tmp36_ = icon;
#line 134 "../src/CertButton.vala"
		_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
#line 134 "../src/CertButton.vala"
		gtk_style_context_add_class (_tmp37_, "warning");
#line 135 "../src/CertButton.vala"
		_tmp38_ = secondary_text;
#line 135 "../src/CertButton.vala"
		_tmp39_ = gtk_widget_get_style_context ((GtkWidget*) _tmp38_);
#line 135 "../src/CertButton.vala"
		gtk_style_context_add_class (_tmp39_, "warning");
#line 720 "CertButton.c"
	}
#line 138 "../src/CertButton.vala"
	_tmp40_ = cert;
#line 138 "../src/CertButton.vala"
	g_object_get (_tmp40_, "certificate", &_tmp41_, NULL);
#line 138 "../src/CertButton.vala"
	_tmp42_ = _tmp41_;
#line 138 "../src/CertButton.vala"
	_tmp43_ = _tmp42_;
#line 138 "../src/CertButton.vala"
	_tmp44_ = _tmp43_->data;
#line 138 "../src/CertButton.vala"
	_tmp44__length1 = _tmp43_->len;
#line 138 "../src/CertButton.vala"
	_tmp45_ = (GcrSimpleCertificate*) gcr_simple_certificate_new (_tmp44_, _tmp44__length1);
#line 138 "../src/CertButton.vala"
	_tmp46_ = _tmp45_;
#line 138 "../src/CertButton.vala"
	_g_byte_array_unref0 (_tmp43_);
#line 138 "../src/CertButton.vala"
	gcr_cert = _tmp46_;
#line 139 "../src/CertButton.vala"
	_tmp47_ = gcr_cert;
#line 139 "../src/CertButton.vala"
	_tmp48_ = gcr_certificate_widget_new ((GcrCertificate*) _tmp47_);
#line 139 "../src/CertButton.vala"
	g_object_ref_sink (_tmp48_);
#line 139 "../src/CertButton.vala"
	cert_details = _tmp48_;
#line 141 "../src/CertButton.vala"
	_tmp49_ = (GtkGrid*) gtk_grid_new ();
#line 141 "../src/CertButton.vala"
	g_object_ref_sink (_tmp49_);
#line 141 "../src/CertButton.vala"
	grid = _tmp49_;
#line 142 "../src/CertButton.vala"
	_tmp50_ = grid;
#line 142 "../src/CertButton.vala"
	gtk_grid_set_column_spacing (_tmp50_, 3);
#line 143 "../src/CertButton.vala"
	_tmp51_ = grid;
#line 143 "../src/CertButton.vala"
	_tmp52_ = icon;
#line 143 "../src/CertButton.vala"
	gtk_grid_attach (_tmp51_, (GtkWidget*) _tmp52_, 0, 0, 1, 2);
#line 144 "../src/CertButton.vala"
	_tmp53_ = grid;
#line 144 "../src/CertButton.vala"
	_tmp54_ = primary_text;
#line 144 "../src/CertButton.vala"
	gtk_grid_attach (_tmp53_, (GtkWidget*) _tmp54_, 1, 0, 1, 1);
#line 145 "../src/CertButton.vala"
	_tmp55_ = grid;
#line 145 "../src/CertButton.vala"
	_tmp56_ = secondary_text;
#line 145 "../src/CertButton.vala"
	gtk_grid_attach (_tmp55_, (GtkWidget*) _tmp56_, 1, 1, 1, 1);
#line 146 "../src/CertButton.vala"
	_tmp57_ = grid;
#line 146 "../src/CertButton.vala"
	_tmp58_ = cert_details;
#line 146 "../src/CertButton.vala"
	gtk_grid_attach (_tmp57_, (GtkWidget*) _tmp58_, 1, 2, 1, 1);
#line 148 "../src/CertButton.vala"
	_tmp59_ = _data3_->popover;
#line 148 "../src/CertButton.vala"
	_tmp60_ = grid;
#line 148 "../src/CertButton.vala"
	gtk_container_add ((GtkContainer*) _tmp59_, (GtkWidget*) _tmp60_);
#line 153 "../src/CertButton.vala"
	_tmp61_ = _data3_->popover;
#line 153 "../src/CertButton.vala"
	g_signal_connect_object ((GtkWidget*) _tmp61_, "button-press-event", (GCallback) ___lambda7__gtk_widget_button_press_event, self, 0);
#line 157 "../src/CertButton.vala"
	_tmp62_ = _data3_->popover;
#line 157 "../src/CertButton.vala"
	g_signal_connect_data ((GtkWidget*) _tmp62_, "button-release-event", (GCallback) ___lambda8__gtk_widget_button_release_event, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 180 "../src/CertButton.vala"
	_tmp63_ = _data3_->popover;
#line 180 "../src/CertButton.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp63_);
#line 182 "../src/CertButton.vala"
	_g_object_unref0 (grid);
#line 182 "../src/CertButton.vala"
	_g_object_unref0 (cert_details);
#line 182 "../src/CertButton.vala"
	_g_object_unref0 (gcr_cert);
#line 182 "../src/CertButton.vala"
	_g_object_unref0 (secondary_text);
#line 182 "../src/CertButton.vala"
	_g_object_unref0 (primary_text);
#line 182 "../src/CertButton.vala"
	_g_object_unref0 (icon);
#line 182 "../src/CertButton.vala"
	_g_object_unref0 (button_icon);
#line 182 "../src/CertButton.vala"
	_g_object_unref0 (cert);
#line 182 "../src/CertButton.vala"
	block3_data_unref (_data3_);
#line 182 "../src/CertButton.vala"
	_data3_ = NULL;
#line 182 "../src/CertButton.vala"
	return;
#line 824 "CertButton.c"
}

CertButtonSecurity
cert_button_get_security (CertButton* self)
{
	CertButtonSecurity result;
#line 32 "../src/CertButton.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 33 "../src/CertButton.vala"
	result = self->priv->_security;
#line 33 "../src/CertButton.vala"
	return result;
#line 837 "CertButton.c"
}

void
cert_button_set_security (CertButton* self,
                          CertButtonSecurity value)
{
	GIcon* icon = NULL;
	gchar* tooltip = NULL;
	GIcon* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	const gchar* _tmp11_;
	gboolean _tmp12_ = FALSE;
#line 35 "../src/CertButton.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/CertButton.vala"
	self->priv->_security = value;
#line 41 "../src/CertButton.vala"
	switch (value) {
#line 41 "../src/CertButton.vala"
		case CERT_BUTTON_SECURITY_LOADING:
#line 859 "CertButton.c"
		{
			GThemedIcon* _tmp0_;
			gchar* _tmp1_;
#line 43 "../src/CertButton.vala"
			_tmp0_ = (GThemedIcon*) g_themed_icon_new ("content-loading-symbolic");
#line 43 "../src/CertButton.vala"
			_g_object_unref0 (icon);
#line 43 "../src/CertButton.vala"
			icon = (GIcon*) _tmp0_;
#line 44 "../src/CertButton.vala"
			_tmp1_ = g_strdup (_ ("Loading captive portal."));
#line 44 "../src/CertButton.vala"
			_g_free0 (tooltip);
#line 44 "../src/CertButton.vala"
			tooltip = _tmp1_;
#line 45 "../src/CertButton.vala"
			break;
#line 877 "CertButton.c"
		}
#line 41 "../src/CertButton.vala"
		case CERT_BUTTON_SECURITY_NONE:
#line 881 "CertButton.c"
		{
			GThemedIcon* _tmp2_;
			gchar* _tmp3_;
#line 47 "../src/CertButton.vala"
			_tmp2_ = (GThemedIcon*) g_themed_icon_new ("security-low-symbolic");
#line 47 "../src/CertButton.vala"
			_g_object_unref0 (icon);
#line 47 "../src/CertButton.vala"
			icon = (GIcon*) _tmp2_;
#line 48 "../src/CertButton.vala"
			_tmp3_ = g_strdup (_ ("The page is served over an unprotected connection."));
#line 48 "../src/CertButton.vala"
			_g_free0 (tooltip);
#line 48 "../src/CertButton.vala"
			tooltip = _tmp3_;
#line 49 "../src/CertButton.vala"
			break;
#line 899 "CertButton.c"
		}
#line 41 "../src/CertButton.vala"
		case CERT_BUTTON_SECURITY_SECURE:
#line 903 "CertButton.c"
		{
			GThemedIcon* _tmp4_;
			gchar* _tmp5_;
#line 52 "../src/CertButton.vala"
			_tmp4_ = (GThemedIcon*) g_themed_icon_new ("security-high-symbolic");
#line 52 "../src/CertButton.vala"
			_g_object_unref0 (icon);
#line 52 "../src/CertButton.vala"
			icon = (GIcon*) _tmp4_;
#line 53 "../src/CertButton.vala"
			_tmp5_ = g_strdup (_ ("The page is served over a protected connection."));
#line 53 "../src/CertButton.vala"
			_g_free0 (tooltip);
#line 53 "../src/CertButton.vala"
			tooltip = _tmp5_;
#line 54 "../src/CertButton.vala"
			break;
#line 921 "CertButton.c"
		}
#line 41 "../src/CertButton.vala"
		case CERT_BUTTON_SECURITY_MIXED_CONTENT:
#line 925 "CertButton.c"
		{
			GThemedIcon* _tmp6_;
			gchar* _tmp7_;
#line 57 "../src/CertButton.vala"
			_tmp6_ = (GThemedIcon*) g_themed_icon_new ("security-medium-symbolic");
#line 57 "../src/CertButton.vala"
			_g_object_unref0 (icon);
#line 57 "../src/CertButton.vala"
			icon = (GIcon*) _tmp6_;
#line 58 "../src/CertButton.vala"
			_tmp7_ = g_strdup (_ ("Some elements of this page are served over an unprotected connection."));
#line 58 "../src/CertButton.vala"
			_g_free0 (tooltip);
#line 58 "../src/CertButton.vala"
			tooltip = _tmp7_;
#line 59 "../src/CertButton.vala"
			break;
#line 943 "CertButton.c"
		}
		default:
		{
#line 62 "../src/CertButton.vala"
			g_assert_not_reached ();
#line 949 "CertButton.c"
		}
	}
#line 65 "../src/CertButton.vala"
	_tmp8_ = icon;
#line 65 "../src/CertButton.vala"
	_tmp9_ = (GtkImage*) gtk_image_new_from_gicon (_tmp8_, (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 65 "../src/CertButton.vala"
	g_object_ref_sink (_tmp9_);
#line 65 "../src/CertButton.vala"
	_tmp10_ = _tmp9_;
#line 65 "../src/CertButton.vala"
	gtk_button_set_image ((GtkButton*) self, (GtkWidget*) _tmp10_);
#line 65 "../src/CertButton.vala"
	_g_object_unref0 (_tmp10_);
#line 66 "../src/CertButton.vala"
	_tmp11_ = tooltip;
#line 66 "../src/CertButton.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp11_);
#line 67 "../src/CertButton.vala"
	if (value != CERT_BUTTON_SECURITY_NONE) {
#line 67 "../src/CertButton.vala"
		_tmp12_ = value != CERT_BUTTON_SECURITY_LOADING;
#line 972 "CertButton.c"
	} else {
#line 67 "../src/CertButton.vala"
		_tmp12_ = FALSE;
#line 976 "CertButton.c"
	}
#line 67 "../src/CertButton.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp12_);
#line 35 "../src/CertButton.vala"
	_g_free0 (tooltip);
#line 35 "../src/CertButton.vala"
	_g_object_unref0 (icon);
#line 35 "../src/CertButton.vala"
	g_object_notify_by_pspec ((GObject *) self, cert_button_properties[CERT_BUTTON_SECURITY_PROPERTY]);
#line 986 "CertButton.c"
}

CaptiveLogin*
cert_button_get_captive_login_window (CertButton* self)
{
	CaptiveLogin* result;
	CaptiveLogin* _tmp0_;
#line 72 "../src/CertButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/CertButton.vala"
	_tmp0_ = self->priv->_captive_login_window;
#line 72 "../src/CertButton.vala"
	result = _tmp0_;
#line 72 "../src/CertButton.vala"
	return result;
#line 1002 "CertButton.c"
}

void
cert_button_set_captive_login_window (CertButton* self,
                                      CaptiveLogin* value)
{
	CaptiveLogin* old_value;
#line 72 "../src/CertButton.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/CertButton.vala"
	old_value = cert_button_get_captive_login_window (self);
#line 72 "../src/CertButton.vala"
	if (old_value != value) {
#line 1016 "CertButton.c"
		CaptiveLogin* _tmp0_;
#line 72 "../src/CertButton.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 72 "../src/CertButton.vala"
		_g_object_unref0 (self->priv->_captive_login_window);
#line 72 "../src/CertButton.vala"
		self->priv->_captive_login_window = _tmp0_;
#line 72 "../src/CertButton.vala"
		g_object_notify_by_pspec ((GObject *) self, cert_button_properties[CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY]);
#line 1026 "CertButton.c"
	}
}

static void
_cert_button_on_tls_button_click_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                            gpointer self)
{
#line 84 "../src/CertButton.vala"
	cert_button_on_tls_button_click ((CertButton*) self);
#line 1036 "CertButton.c"
}

static GObject *
cert_button_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CertButton * self;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
#line 79 "../src/CertButton.vala"
	parent_class = G_OBJECT_CLASS (cert_button_parent_class);
#line 79 "../src/CertButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 79 "../src/CertButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CERT_BUTTON, CertButton);
#line 80 "../src/CertButton.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 80 "../src/CertButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 80 "../src/CertButton.vala"
	style_context = _tmp1_;
#line 81 "../src/CertButton.vala"
	_tmp2_ = style_context;
#line 81 "../src/CertButton.vala"
	gtk_style_context_add_class (_tmp2_, GTK_STYLE_CLASS_FLAT);
#line 82 "../src/CertButton.vala"
	_tmp3_ = style_context;
#line 82 "../src/CertButton.vala"
	gtk_style_context_add_class (_tmp3_, "titlebutton");
#line 84 "../src/CertButton.vala"
	g_signal_connect_object ((GtkToggleButton*) self, "toggled", (GCallback) _cert_button_on_tls_button_click_gtk_toggle_button_toggled, self, 0);
#line 79 "../src/CertButton.vala"
	_g_object_unref0 (style_context);
#line 79 "../src/CertButton.vala"
	return obj;
#line 1078 "CertButton.c"
}

static void
cert_button_class_init (CertButtonClass * klass,
                        gpointer klass_data)
{
#line 21 "../src/CertButton.vala"
	cert_button_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/CertButton.vala"
	g_type_class_adjust_private_offset (klass, &CertButton_private_offset);
#line 21 "../src/CertButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_cert_button_get_property;
#line 21 "../src/CertButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_cert_button_set_property;
#line 21 "../src/CertButton.vala"
	G_OBJECT_CLASS (klass)->constructor = cert_button_constructor;
#line 21 "../src/CertButton.vala"
	G_OBJECT_CLASS (klass)->finalize = cert_button_finalize;
#line 21 "../src/CertButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERT_BUTTON_SECURITY_PROPERTY, cert_button_properties[CERT_BUTTON_SECURITY_PROPERTY] = g_param_spec_enum ("security", "security", "security", CERT_BUTTON_TYPE_SECURITY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/CertButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY, cert_button_properties[CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY] = g_param_spec_object ("captive-login-window", "captive-login-window", "captive-login-window", TYPE_CAPTIVE_LOGIN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1101 "CertButton.c"
}

static void
cert_button_instance_init (CertButton * self,
                           gpointer klass)
{
#line 21 "../src/CertButton.vala"
	self->priv = cert_button_get_instance_private (self);
#line 1110 "CertButton.c"
}

static void
cert_button_finalize (GObject * obj)
{
	CertButton * self;
#line 21 "../src/CertButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CERT_BUTTON, CertButton);
#line 71 "../src/CertButton.vala"
	_g_object_unref0 (self->priv->_captive_login_window);
#line 21 "../src/CertButton.vala"
	G_OBJECT_CLASS (cert_button_parent_class)->finalize (obj);
#line 1123 "CertButton.c"
}

static GType
cert_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CertButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cert_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CertButton), 0, (GInstanceInitFunc) cert_button_instance_init, NULL };
	GType cert_button_type_id;
	cert_button_type_id = g_type_register_static (gtk_toggle_button_get_type (), "CertButton", &g_define_type_info, 0);
	CertButton_private_offset = g_type_add_instance_private (cert_button_type_id, sizeof (CertButtonPrivate));
	return cert_button_type_id;
}

GType
cert_button_get_type (void)
{
	static volatile gsize cert_button_type_id__once = 0;
	if (g_once_init_enter (&cert_button_type_id__once)) {
		GType cert_button_type_id;
		cert_button_type_id = cert_button_get_type_once ();
		g_once_init_leave (&cert_button_type_id__once, cert_button_type_id);
	}
	return cert_button_type_id__once;
}

static void
_vala_cert_button_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	CertButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CERT_BUTTON, CertButton);
#line 21 "../src/CertButton.vala"
	switch (property_id) {
#line 21 "../src/CertButton.vala"
		case CERT_BUTTON_SECURITY_PROPERTY:
#line 21 "../src/CertButton.vala"
		g_value_set_enum (value, cert_button_get_security (self));
#line 21 "../src/CertButton.vala"
		break;
#line 21 "../src/CertButton.vala"
		case CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY:
#line 21 "../src/CertButton.vala"
		g_value_set_object (value, cert_button_get_captive_login_window (self));
#line 21 "../src/CertButton.vala"
		break;
#line 1170 "CertButton.c"
		default:
#line 21 "../src/CertButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/CertButton.vala"
		break;
#line 1176 "CertButton.c"
	}
}

static void
_vala_cert_button_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	CertButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CERT_BUTTON, CertButton);
#line 21 "../src/CertButton.vala"
	switch (property_id) {
#line 21 "../src/CertButton.vala"
		case CERT_BUTTON_SECURITY_PROPERTY:
#line 21 "../src/CertButton.vala"
		cert_button_set_security (self, g_value_get_enum (value));
#line 21 "../src/CertButton.vala"
		break;
#line 21 "../src/CertButton.vala"
		case CERT_BUTTON_CAPTIVE_LOGIN_WINDOW_PROPERTY:
#line 21 "../src/CertButton.vala"
		cert_button_set_captive_login_window (self, g_value_get_object (value));
#line 21 "../src/CertButton.vala"
		break;
#line 1202 "CertButton.c"
		default:
#line 21 "../src/CertButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/CertButton.vala"
		break;
#line 1208 "CertButton.c"
	}
}

